/*
 * Copyright (C) 1992, Board of Trustees of the University of Illinois.
 *
 * Permission is granted to copy and distribute source with out fee.
 * Commercialization of this product requires prior licensing
 * from the National Center for Supercomputing Applications of the
 * University of Illinois.  Commercialization includes the integration of this 
 * code in part or whole into a product for resale.  Free distribution of 
 * unmodified source and use of NCSA software is not considered 
 * commercialization.
 *
 */
/* $Id: view.h,v 1.4 1993/07/21 21:58:26 gbourhis Exp $ */


#include "data.h"
#include "dhash.h"

struct match_rec {
	struct view_rec *V;
	Widget widget;
	int red, green, blue;
};

#ifndef V_RASTER
# define	V_RASTER	1
# define	V_WHITEBOARD	2
# define	V_SHEET		3
# define	V_TEXT		4
#endif
#define	V_3DPANEL	5

struct view_rec {
		int type;
		int Mode;
		int lastMode;
		int text_x, text_y, ret_x;
		int Scroll_x, Scroll_y;
		int pt_x, pt_y;
		int line_x1, line_y1, line_x2, line_y2;
		int area_x1, area_y1, area_x2, area_y2;
		int doodleWidth;
		unsigned long doodleColor;
		Colormap cmap;
		Widget shell;
		Widget drawArea;
		Widget colorpal;
		Widget toolform;
		Widget palform;
		Widget rowwin;
		Widget colwin;
		Widget vscroll;
		Widget hscroll;
		Widget lastToggle;
		Widget dialog;
		Widget optionMenu;
		Widget operationMenu;
		Widget palPulldown;
		XImage *cutbuffer;
		Pixmap drawPix;
		Pixmap doodlePix;
		Dptr *Doodles;
		struct match_rec *matchButton;
		struct match_rec *buttonPal[9];
		Boolean isUp;
		Boolean ispub;
		Boolean viewEntirePal;
		Boolean viewOverlay;
		Boolean areaSelect;
		Boolean lineSelect;
		Boolean pointSelect;
		struct data_rec *cData;
		struct view_rec *next;
		};

typedef struct view_rec View;

struct pal_view {
	View *V;
	Palette *p;
};

